#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int printnumbers(unsigned itcm , unsigned dtcm, unsigned ocram, unsigned flash,
		 unsigned itcmm, unsigned dtcmm, unsigned ocramm, unsigned flashm)
{
	printf("ITCM : %6d B\t(%5.2f%% of %4d KB)\r", itcm, itcm / (itcmm*1024.0)*100, itcmm);
	printf("DTCM : %6d B\t(%5.2f%% of %4d KB)\r", dtcm, dtcm / (dtcmm*1024.0)*100, dtcmm);	
	printf("OCRAM: %6d B\t(%5.2f%% of %4d KB)\r", ocram, ocram / (ocramm*1024.0)*100, ocramm);	
	printf("Flash: %6d B\t(%5.2f%% of %4d KB)\r", flash, flash / (flashm*1024.0)*100, flashm);	
}


int main( ) {
   const int bl = 200;
   char str[bl+1];
   char *s;
   
   unsigned teensy_model_identifier = 0;
   unsigned stext = 0;
   unsigned etext = 0;
   unsigned sdata = 0;
   unsigned ebss = 0;	
   unsigned flashimagelen = 0;
   unsigned heap_start = 0;
   
   do {
	s = gets( str );
	if (s) {
		str[bl] = 0;
		if (strstr(str, "_teensy_model_identifier")) teensy_model_identifier = strtol(str, NULL, 16); 
		if (strstr(str, "T _stext")) stext = strtol(str, NULL, 16); 
		if (strstr(str, "T _etext")) etext = strtol(str, NULL, 16); 
		if (strstr(str, "D _sdata")) sdata = strtol(str, NULL, 16); 
		if (strstr(str, "B _ebss")) ebss = strtol(str, NULL, 16); 	
		if (strstr(str, " _heap_start")) heap_start = strtol(str, NULL, 16); 
		if (strstr(str, " _flashimagelen")) flashimagelen = strtol(str, NULL, 16); 		
		//puts( str );
	}
   } while(s);
   
   if (teensy_model_identifier == 0x24) {
	printnumbers(etext - stext, ebss - sdata, heap_start - 0x20200000,flashimagelen, 128, 128, 256, 1536);
   }
   
   return 0;
}
